thoughts/src/h12title

51 lines
1.3 KiB
Bash
Executable File

#!/bin/bash
# Copies first body h1 text into title
#
# Copyright (C) 2019 Mike Gerwitz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
# This assumes that an <article> tag exists and assumes that is the main
# content from which the title ought to be derived.
##
set -euo pipefail
main()
{
local -r placeholder=${1?Missing placeholder}
local body;
body=$( cat )
local title
title=$(
<<<"$body" grep -A10 '<main' \
| grep '<h1' \
| head -n1 \
| grep -oP '(?<=>)[^<]+' \
) || {
echo 'error: h12title: failed to locate heading' >&2
exit 1
}
sed "s#$placeholder#${title/&/\\&}#" <<< "$body" || {
printf "error: h12title: failed title replacement: '%s'\n" "$title" >&2
exit 1
}
}
main "$@"